install.sh 7.3 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244
  1. #!/bin/sh
  2. # This script installs Ollama on Linux.
  3. # It detects the current operating system architecture and installs the appropriate version of Ollama.
  4. set -eu
  5. status() { echo ">>> $*" >&2; }
  6. error() { echo "ERROR $*"; exit 1; }
  7. warning() { echo "WARNING: $*"; }
  8. TEMP_DIR=$(mktemp -d)
  9. cleanup() { rm -rf $TEMP_DIR; }
  10. trap cleanup EXIT
  11. available() { command -v $1 >/dev/null; }
  12. require() {
  13. local MISSING=''
  14. for TOOL in $*; do
  15. if ! available $TOOL; then
  16. MISSING="$MISSING $TOOL"
  17. fi
  18. done
  19. echo $MISSING
  20. }
  21. [ "$(uname -s)" = "Linux" ] || error 'This script is intended to run on Linux only.'
  22. ARCH=$(uname -m)
  23. case "$ARCH" in
  24. x86_64) ARCH="amd64" ;;
  25. aarch64|arm64) ARCH="arm64" ;;
  26. *) error "Unsupported architecture: $ARCH" ;;
  27. esac
  28. SUDO=
  29. if [ "$(id -u)" -ne 0 ]; then
  30. # Running as root, no need for sudo
  31. if ! available sudo; then
  32. error "This script requires superuser permissions. Please re-run as root."
  33. fi
  34. SUDO="sudo"
  35. fi
  36. NEEDS=$(require curl awk grep sed tee xargs)
  37. if [ -n "$NEEDS" ]; then
  38. status "ERROR: The following tools are required but missing:"
  39. for NEED in $NEEDS; do
  40. echo " - $NEED"
  41. done
  42. exit 1
  43. fi
  44. status "Downloading ollama..."
  45. curl --fail --show-error --location --progress-bar -o $TEMP_DIR/ollama "https://ollama.ai/download/ollama-linux-$ARCH"
  46. for BINDIR in /usr/local/bin /usr/bin /bin; do
  47. echo $PATH | grep -q $BINDIR && break || continue
  48. done
  49. status "Installing ollama to $BINDIR..."
  50. $SUDO install -o0 -g0 -m755 -d $BINDIR
  51. $SUDO install -o0 -g0 -m755 $TEMP_DIR/ollama $BINDIR/ollama
  52. install_success() { status 'Install complete. Run "ollama" from the command line.'; }
  53. trap install_success EXIT
  54. # Everything from this point onwards is optional.
  55. configure_systemd() {
  56. if ! id ollama >/dev/null 2>&1; then
  57. status "Creating ollama user..."
  58. $SUDO useradd -r -s /bin/false -m -d /usr/share/ollama ollama
  59. fi
  60. status "Creating ollama systemd service..."
  61. cat <<EOF | $SUDO tee /etc/systemd/system/ollama.service >/dev/null
  62. [Unit]
  63. Description=Ollama Service
  64. After=network-online.target
  65. [Service]
  66. ExecStart=$BINDIR/ollama serve
  67. User=ollama
  68. Group=ollama
  69. Restart=always
  70. RestartSec=3
  71. Environment="HOME=/usr/share/ollama"
  72. Environment="PATH=$PATH"
  73. [Install]
  74. WantedBy=default.target
  75. EOF
  76. SYSTEMCTL_RUNNING="$(systemctl is-system-running || true)"
  77. case $SYSTEMCTL_RUNNING in
  78. running|degraded)
  79. status "Enabling and starting ollama service..."
  80. $SUDO systemctl daemon-reload
  81. $SUDO systemctl enable ollama
  82. start_service() { $SUDO systemctl restart ollama; }
  83. trap start_service EXIT
  84. ;;
  85. esac
  86. }
  87. if available systemctl; then
  88. configure_systemd
  89. fi
  90. if ! available lspci && ! available lshw; then
  91. warning "Unable to detect NVIDIA GPU. Install lspci or lshw to automatically detect and install NVIDIA CUDA drivers."
  92. exit 0
  93. fi
  94. check_gpu() {
  95. case $1 in
  96. lspci) available lspci && lspci -d '10de:' | grep -q 'NVIDIA' || return 1 ;;
  97. lshw) available lshw && $SUDO lshw -c display -numeric | grep -q 'vendor: .* \[10DE\]' || return 1 ;;
  98. nvidia-smi) available nvidia-smi || return 1 ;;
  99. esac
  100. }
  101. if check_gpu nvidia-smi; then
  102. status "NVIDIA GPU installed."
  103. exit 0
  104. fi
  105. if ! check_gpu lspci && ! check_gpu lshw; then
  106. warning "No NVIDIA GPU detected. Ollama will run in CPU-only mode."
  107. exit 0
  108. fi
  109. # ref: https://docs.nvidia.com/cuda/cuda-installation-guide-linux/index.html#rhel-7-centos-7
  110. # ref: https://docs.nvidia.com/cuda/cuda-installation-guide-linux/index.html#rhel-8-rocky-8
  111. # ref: https://docs.nvidia.com/cuda/cuda-installation-guide-linux/index.html#rhel-9-rocky-9
  112. # ref: https://docs.nvidia.com/cuda/cuda-installation-guide-linux/index.html#fedora
  113. install_cuda_driver_yum() {
  114. status 'Installing NVIDIA repository...'
  115. case $PACKAGE_MANAGER in
  116. yum)
  117. $SUDO $PACKAGE_MANAGER -y install yum-utils
  118. $SUDO $PACKAGE_MANAGER-config-manager --add-repo https://developer.download.nvidia.com/compute/cuda/repos/$1$2/$(uname -m)/cuda-$1$2.repo
  119. ;;
  120. dnf)
  121. $SUDO $PACKAGE_MANAGER config-manager --add-repo https://developer.download.nvidia.com/compute/cuda/repos/$1$2/$(uname -m)/cuda-$1$2.repo
  122. ;;
  123. esac
  124. case $1 in
  125. rhel)
  126. status 'Installing EPEL repository...'
  127. # EPEL is required for third-party dependencies such as dkms and libvdpau
  128. $SUDO $PACKAGE_MANAGER -y install https://dl.fedoraproject.org/pub/epel/epel-release-latest-$2.noarch.rpm || true
  129. ;;
  130. esac
  131. status 'Installing CUDA driver...'
  132. if [ "$1" = 'centos' ] || [ "$1$2" = 'rhel7' ]; then
  133. $SUDO $PACKAGE_MANAGER -y install nvidia-driver-latest-dkms
  134. fi
  135. $SUDO $PACKAGE_MANAGER -y install cuda-drivers
  136. }
  137. # ref: https://docs.nvidia.com/cuda/cuda-installation-guide-linux/index.html#ubuntu
  138. # ref: https://docs.nvidia.com/cuda/cuda-installation-guide-linux/index.html#debian
  139. install_cuda_driver_apt() {
  140. status 'Installing NVIDIA repository...'
  141. curl -fsSL -o $TEMP_DIR/cuda-keyring.deb https://developer.download.nvidia.com/compute/cuda/repos/$1$2/$(uname -m)/cuda-keyring_1.1-1_all.deb
  142. case $1 in
  143. debian)
  144. status 'Enabling contrib sources...'
  145. $SUDO sed 's/main/contrib/' < /etc/apt/sources.list | sudo tee /etc/apt/sources.list.d/contrib.list > /dev/null
  146. ;;
  147. esac
  148. status 'Installing CUDA driver...'
  149. $SUDO dpkg -i $TEMP_DIR/cuda-keyring.deb
  150. $SUDO apt-get update
  151. [ -n "$SUDO" ] && SUDO_E="$SUDO -E" || SUDO_E=
  152. DEBIAN_FRONTEND=noninteractive $SUDO_E apt-get -y install cuda-drivers -q
  153. }
  154. if [ ! -f "/etc/os-release" ]; then
  155. error "Unknown distribution. Skipping CUDA installation."
  156. fi
  157. . /etc/os-release
  158. OS_NAME=$ID
  159. OS_VERSION=$VERSION_ID
  160. PACKAGE_MANAGER=
  161. for PACKAGE_MANAGER in dnf yum apt-get; do
  162. if available $PACKAGE_MANAGER; then
  163. break
  164. fi
  165. done
  166. if [ -z "$PACKAGE_MANAGER" ]; then
  167. error "Unknown package manager. Skipping CUDA installation."
  168. fi
  169. if ! check_gpu nvidia-smi || [ -z "$(nvidia-smi | grep -o "CUDA Version: [0-9]*\.[0-9]*")" ]; then
  170. case $OS_NAME in
  171. centos|rhel) install_cuda_driver_yum 'rhel' $OS_VERSION ;;
  172. rocky) install_cuda_driver_yum 'rhel' $(echo $OS_VERSION | cut -c1) ;;
  173. fedora) install_cuda_driver_yum $OS_NAME $OS_VERSION ;;
  174. amzn) install_cuda_driver_yum 'fedora' '35' ;;
  175. debian) install_cuda_driver_apt $OS_NAME $OS_VERSION ;;
  176. ubuntu) install_cuda_driver_apt $OS_NAME $(echo $OS_VERSION | sed 's/\.//') ;;
  177. *) exit ;;
  178. esac
  179. fi
  180. if ! lsmod | grep -q nvidia; then
  181. KERNEL_RELEASE="$(uname -r)"
  182. case $OS_NAME in
  183. centos|rhel|rocky|amzn) $SUDO $PACKAGE_MANAGER -y install kernel-devel-$KERNEL_RELEASE kernel-headers-$KERNEL_RELEASE ;;
  184. fedora) $SUDO $PACKAGE_MANAGER -y install kernel-devel-$KERNEL_RELEASE ;;
  185. debian|ubuntu) $SUDO apt-get -y install linux-headers-$KERNEL_RELEASE ;;
  186. *) exit ;;
  187. esac
  188. NVIDIA_CUDA_VERSION=$($SUDO dkms status | awk -F: '/added/ { print $1 }')
  189. if [ -n "$NVIDIA_CUDA_VERSION" ]; then
  190. $SUDO dkms install $NVIDIA_CUDA_VERSION
  191. fi
  192. if lsmod | grep -q nouveau; then
  193. status 'Reboot to complete NVIDIA CUDA driver install.'
  194. exit 0
  195. fi
  196. $SUDO modprobe nvidia
  197. fi
  198. status "NVIDIA CUDA drivers installed."